'
' A test of memory functions using MMX and SSE
'
VERSION "0.0001"
CONSOLE
'
IMPORT "xst"
IMPORT "xsx"
IMPORT "kernel32"

m4_include(`macros.def.x')

m4_include(`mem.def.x')

DECLARE FUNCTION Entry ()
DECLARE FUNCTION DoTest (strMult)

m4_include(`mem.dec')

'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()
SHARED IOctrl IOcontrol



	IO_Init()
	flags=IOcontrol.flags

	FOR i=-1 TO 4
	PRINT
	PRINT "--- ROUND";i+2;" ---"
	PRINT
	DoTest(i)
	FLAG_CLEARS(IOcontrol,($$IO_MMX OR $$IO_SSE))
	DoTest(i)
	IOcontrol.flags=flags
	NEXT


  a$ = INLINE$ ("Press Enter to quit >")

	IO_Exit()

END FUNCTION
'
' ####################
' #####  DoTest  #####
' ####################
'
'
'
FUNCTION DoTest (strMult)
SHARED IOctrl IOcontrol
STATIC test
GIANT tStart,tEnd,tFreq
SINGLE ms

	PRINT "---------------"
	PRINT "--- TESTING ---"
	PRINT "---------------"
	INC test

	IF FLAG_TESTS(IOcontrol,$$IO_MMX) THEN PRINT "This code uses MMX"
	IF FLAG_TESTS(IOcontrol,$$IO_SSE) THEN PRINT "This code uses SSE"

	fl=OPEN("mem.x",$$RD)
	a$=NULL$(LOF(fl))
	READ [fl],a$
	CLOSE (fl)

	'increase string len ^strMult
	FOR i=0 TO strMult
		a$=a$+a$
	NEXT


	PRINT "Loaded Block LEN:";LEN(a$)

	XstSleep(1000)

'***************
'*** COPYING ***
'***************

	PRINT "Copying ";
	b$=NULL$(LEN(a$))

	QueryPerformanceCounter(&tStart)

	FOR i=1 TO 1000
		mCopy(&b$,&a$,LEN(a$))
	NEXT

	PrintElapsedMs(tStart,tEnd,tFreq)

'***************
'*** FILLING ***
'***************

	PRINT "Filling ";

	QueryPerformanceCounter(&tStart)

	FOR i=0 TO 1000
		mFill(&b$,LEN(b$),0)
	NEXT

	PrintElapsedMs(tStart,tEnd,tFreq)

'**********************************
'*** COMPARING IDENTICAL BLOCKS ***
'**********************************

	PRINT "Comparing identicals blocks ";

	mCopy(&b$,&a$,LEN(a$))

	QueryPerformanceCounter(&tStart)

	FOR i=0 TO 1000
		mCompare(&b$,&a$,LEN(a$))
	NEXT

	PrintElapsedMs(tStart,tEnd,tFreq)

'***********************************
'*** COMPARING DIFFERENTS BLOCKS ***
'***********************************

	PRINT "Comparing differents blocks ";

	QueryPerformanceCounter(&tStart)

	count=100
	step=LEN(a$)/count

	FOR i=(count-1) TO 1 STEP -1
		UBYTEAT(&b$+(i*step))=0
		mCompare(&b$,&a$,LEN(a$))
	NEXT

	PrintElapsedMs(tStart,tEnd,tFreq)

END FUNCTION

m4_include(`mem.x')

END PROGRAM